CMSIS DSP Software Library: Bilinear Interpolation

Functions

# Bilinear Interpolation
[Interpolation Functions]

## Functions
static __INLINE float32_t | arm_bilinear_interp_f32 (const arm_bilinear_interp_instance_f32 *S, float32_t X, float32_t Y)
static __INLINE q31_t | arm_bilinear_interp_q31 (arm_bilinear_interp_instance_q31 *S, q31_t X, q31_t Y)
static __INLINE q15_t | arm_bilinear_interp_q15 (arm_bilinear_interp_instance_q15 *S, q31_t X, q31_t Y)
static __INLINE q7_t | arm_bilinear_interp_q7 (arm_bilinear_interp_instance_q7 *S, q31_t X, q31_t Y)

## Detailed Description

Bilinear interpolation is an extension of linear interpolation applied to a two dimensional grid. The underlying function `f(x, y)` is sampled on a regular grid and the interpolation process determines values between the grid points. Bilinear interpolation is equivalent to two step linear interpolation, first in the x-dimension and then in the y-dimension. Bilinear interpolation is often used in image processing to rescale images. The CMSIS DSP library provides bilinear interpolation functions for Q7, Q15, Q31, and floating-point data types.

Algorithm

  The instance structure used by the bilinear interpolation functions describes a two dimensional data table. For floating-point, the instance structure is defined as:

         typedef struct
         {
           uint16_t numRows;
           uint16_t numCols;
           float32_t *pData;
       } arm_bilinear_interp_instance_f32;

  where `numRows` specifies the number of rows in the table; `numCols` specifies the number of columns in the table; and `pData` points to an array of size `numRows*numCols` values. The data table `pTable` is organized in row order and the supplied data values fall on integer indexes. That is, table element (x,y) is located at `pTable[x + y*numCols]` where x and y are integers.

  Let `(x, y)` specify the desired interpolation point. Then define:

           XF = floor(x)
           YF = floor(y)

  The interpolated output point is computed as:

        f(x, y) = f(XF, YF) * (1-(x-XF)) * (1-(y-YF))
                 + f(XF+1, YF) * (x-XF)*(1-(y-YF))
                 + f(XF, YF+1) * (1-(x-XF))*(y-YF)
                 + f(XF+1, YF+1) * (x-XF)*(y-YF)

  Note that the coordinates (x, y) contain integer and fractional components. The integer components specify which portion of the table to use while the fractional components control the interpolation processor.

  if (x,y) are outside of the table boundary, Bilinear interpolation returns zero output.

## Function Documentation

static __INLINE float32_t arm_bilinear_interp_f32 | ( | const arm_bilinear_interp_instance_f32 * | S,
|  | float32_t | X,
|  | float32_t | Y
| ) |  | `[static]`

Floating-point bilinear interpolation.

Parameters:

  [in,out] | *S | points to an instance of the interpolation structure.
  [in] | X | interpolation coordinate.
  [in] | Y | interpolation coordinate.

Returns:
  out interpolated value.

Definition at line 6739 of file arm_math.h.

static __INLINE q31_t arm_bilinear_interp_q31 | ( | arm_bilinear_interp_instance_q31 * | S,
|  | q31_t | X,
|  | q31_t | Y
| ) |  | `[static]`

Q31 bilinear interpolation.

Parameters:

  [in,out] | *S | points to an instance of the interpolation structure.
  [in] | X | interpolation coordinate in 12.20 format.
  [in] | Y | interpolation coordinate in 12.20 format.

Returns:
  out interpolated value.

Definition at line 6806 of file arm_math.h.

static __INLINE q15_t arm_bilinear_interp_q15 | ( | arm_bilinear_interp_instance_q15 * | S,
|  | q31_t | X,
|  | q31_t | Y
| ) |  | `[static]`

Q15 bilinear interpolation.

Parameters:

  [in,out] | *S | points to an instance of the interpolation structure.
  [in] | X | interpolation coordinate in 12.20 format.
  [in] | Y | interpolation coordinate in 12.20 format.

Returns:
  out interpolated value.

Definition at line 6882 of file arm_math.h.

static __INLINE q7_t arm_bilinear_interp_q7 | ( | arm_bilinear_interp_instance_q7 * | S,
|  | q31_t | X,
|  | q31_t | Y
| ) |  | `[static]`

Q7 bilinear interpolation.

Parameters:

  [in,out] | *S | points to an instance of the interpolation structure.
  [in] | X | interpolation coordinate in 12.20 format.
  [in] | Y | interpolation coordinate in 12.20 format.

Returns:
  out interpolated value.

Definition at line 6962 of file arm_math.h.

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines